import 'package:example/main.dart';
import 'package:example/widgets.dart';
import 'package:flutter/material.dart';
import 'package:beamer/beamer.dart';

class BeamerApp extends StatefulWidget {
  @override
  State<BeamerApp> createState() => _BeamerAppState();
}

class _BeamerAppState extends State<BeamerApp> {
  late final routerDelegate = BeamerDelegate(
    initialPath: '/home1',
    locationBuilder: RoutesLocationBuilder(
      routes: {
        '/*': _buildScaffold,
        '/dashboard/*': _buildScaffold,
        '/settings/*': _buildScaffold,
      },
    ),
  );

  _buildScaffold(context, state, data) {
    return Row(children: [
      const SideBar(),
      Expanded(
        child: Beamer(
          routerDelegate: BeamerDelegate(
              notFoundPage: BeamPage(child: InstructionsScaffold(state.uri.path)),
              locationBuilder: RoutesLocationBuilder(
                routes: {},
              )),
        ),
      ),
    ]);
  }

  @override
  Widget build(BuildContext context) {
    return KeyboardTestHarness(
      setLocation: (location) => routerDelegate.beamToNamed(location),
      child: MaterialApp.router(
        routeInformationParser: BeamerParser(),
        routerDelegate: routerDelegate,
      ),
    );
  }
}
