import 'package:example/main.dart';
import 'package:example/widgets.dart';
import 'package:flutter/material.dart';
import 'package:vrouter/vrouter.dart';

class MyVRouterApp extends StatefulWidget {
  @override
  State<MyVRouterApp> createState() => _MyVRouterAppState();
}

class _MyVRouterAppState extends State<MyVRouterApp> {
  final GlobalKey<VRouterState> _vRouterKey = GlobalKey();

  @override
  Widget build(BuildContext context) {
    return KeyboardTestHarness(
      setLocation: (location) => _vRouterKey.currentState?.to(location),
      child: VRouter(
          key: _vRouterKey,
          builder: (_, navigator) {
            return Row(
              children: [
                const SideBar(),
                Expanded(child: navigator),
              ],
            );
          },
          routes: [
            VWidget.builder(
              path: '*',
              builder: (_, data) => InstructionsScaffold(data.url ?? ''),
            ),
          ]),
    );
  }
}
